/[gentoo-x86]/net-wireless/wpa_supplicant/wpa_supplicant-0.7.3-r5.ebuild
Gentoo

Contents of /net-wireless/wpa_supplicant/wpa_supplicant-0.7.3-r5.ebuild

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.17 - (show annotations) (download)
Fri May 4 06:41:54 2012 UTC (8 years, 3 months ago) by jdhore
Branch: MAIN
Changes since 1.16: +2 -2 lines
dev-util/pkgconfig -> virtual/pkgconfig

(Portage version: 2.2.0_alpha101/cvs/Linux i686)

1 # Copyright 1999-2012 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/net-wireless/wpa_supplicant/wpa_supplicant-0.7.3-r5.ebuild,v 1.16 2012/03/10 17:15:41 ranger Exp $
4
5 EAPI=4
6
7 inherit eutils toolchain-funcs qt4-r2 systemd multilib
8
9 DESCRIPTION="IEEE 802.1X/WPA supplicant for secure wireless transfers"
10 HOMEPAGE="http://hostap.epitest.fi/wpa_supplicant/"
11 SRC_URI="http://hostap.epitest.fi/releases/${P}.tar.gz"
12 LICENSE="|| ( GPL-2 BSD )"
13
14 SLOT="0"
15 KEYWORDS="amd64 arm ~mips ppc ppc64 x86 ~x86-fbsd"
16 IUSE="dbus debug gnutls eap-sim fasteap madwifi ps3 qt4 readline selinux ssl wimax wps kernel_linux kernel_FreeBSD"
17
18 RDEPEND="dbus? ( sys-apps/dbus )
19 kernel_linux? (
20 eap-sim? ( sys-apps/pcsc-lite )
21 madwifi? ( >net-wireless/madwifi-ng-tools-0.9.3 )
22 dev-libs/libnl:1.1
23 )
24 !kernel_linux? ( net-libs/libpcap )
25 qt4? (
26 x11-libs/qt-gui:4
27 x11-libs/qt-svg:4
28 )
29 readline? (
30 sys-libs/ncurses
31 sys-libs/readline
32 )
33 ssl? ( dev-libs/openssl )
34 !ssl? ( gnutls? ( net-libs/gnutls ) )
35 !ssl? ( !gnutls? ( dev-libs/libtommath ) )
36 selinux? ( sec-policy/selinux-networkmanager )"
37 DEPEND="${RDEPEND}
38 virtual/pkgconfig"
39
40 S="${WORKDIR}/${P}/${PN}"
41
42 pkg_setup() {
43 if use fasteap && (use gnutls || use ssl) ; then
44 die "If you use fasteap, you must build with wpa_supplicant's internal TLS implementation. That is, both 'gnutls' and 'ssl' USE flags must be disabled"
45 fi
46
47 if use gnutls && use ssl ; then
48 einfo "You have both 'gnutls' and 'ssl' USE flags enabled: defaulting to USE=\"ssl\""
49 fi
50 }
51
52 src_prepare() {
53 # net/bpf.h needed for net-libs/libpcap on Gentoo/FreeBSD
54 sed -i \
55 -e "s:\(#include <pcap\.h>\):#include <net/bpf.h>\n\1:" \
56 ../src/l2_packet/l2_packet_freebsd.c || die
57
58 # People seem to take the example configuration file too literally (bug #102361)
59 sed -i \
60 -e "s:^\(opensc_engine_path\):#\1:" \
61 -e "s:^\(pkcs11_engine_path\):#\1:" \
62 -e "s:^\(pkcs11_module_path\):#\1:" \
63 wpa_supplicant.conf || die
64
65 # Change configuration to match Gentoo locations (bug #143750)
66 sed -i \
67 -e "s:/usr/lib/opensc:/usr/$(get_libdir):" \
68 -e "s:/usr/lib/pkcs11:/usr/$(get_libdir):" \
69 wpa_supplicant.conf || die
70
71 epatch "${FILESDIR}/${P}-dbus_path_fix.patch"
72
73 # systemd entries to D-Bus service files (bug #372877)
74 echo 'SystemdService=wpa_supplicant.service' \
75 | tee -a dbus/*.service >/dev/null || die
76
77 if use wimax; then
78 cd "${WORKDIR}/${P}"
79 epatch "${FILESDIR}/${P}-generate-libeap-peer.patch"
80
81 # multilib-strict fix (bug #373685)
82 sed -e "s/\/usr\/lib/\/usr\/$(get_libdir)/" -i src/eap_peer/Makefile
83 fi
84
85 # bug (320097)
86 epatch "${FILESDIR}/do-not-call-dbus-functions-with-NULL-path.patch"
87 # https://bugzilla.gnome.org/show_bug.cgi?id=644634
88 epatch "${FILESDIR}/${P}-dbus-api-changes.patch"
89 # bug (374089)
90 epatch "${FILESDIR}/${P}-dbus-WPAIE-fix.patch"
91 }
92
93 src_configure() {
94 # Toolchain setup
95 tc-export CC
96
97 # Basic setup
98 echo "CONFIG_CTRL_IFACE=y" >> .config
99 echo "CONFIG_BACKEND=file" >> .config
100
101 # Basic authentication methods
102 # NOTE: we don't set GPSK or SAKE as they conflict
103 # with the below options
104 echo "CONFIG_EAP_GTC=y" >> .config
105 echo "CONFIG_EAP_MD5=y" >> .config
106 echo "CONFIG_EAP_OTP=y" >> .config
107 echo "CONFIG_EAP_PAX=y" >> .config
108 echo "CONFIG_EAP_PSK=y" >> .config
109 echo "CONFIG_EAP_TLV=y" >> .config
110 echo "CONFIG_IEEE8021X_EAPOL=y" >> .config
111 echo "CONFIG_PKCS12=y" >> .config
112 echo "CONFIG_PEERKEY=y" >> .config
113 echo "CONFIG_EAP_LEAP=y" >> .config
114 echo "CONFIG_EAP_MSCHAPV2=y" >> .config
115 echo "CONFIG_EAP_PEAP=y" >> .config
116 echo "CONFIG_EAP_TLS=y" >> .config
117 echo "CONFIG_EAP_TTLS=y" >> .config
118
119 if use dbus ; then
120 echo "CONFIG_CTRL_IFACE_DBUS=y" >> .config
121 echo "CONFIG_CTRL_IFACE_DBUS_NEW=y" >> .config
122 echo "CONFIG_CTRL_IFACE_DBUS_INTRO=y" >> .config
123 fi
124
125 if use debug ; then
126 echo "CONFIG_DEBUG_FILE=y" >> .config
127 fi
128
129 if use eap-sim ; then
130 # Smart card authentication
131 echo "CONFIG_EAP_SIM=y" >> .config
132 echo "CONFIG_EAP_AKA=y" >> .config
133 echo "CONFIG_EAP_AKA_PRIME=y" >> .config
134 echo "CONFIG_PCSC=y" >> .config
135 fi
136
137 if use fasteap ; then
138 echo "CONFIG_EAP_FAST=y" >> .config
139 fi
140
141 if use readline ; then
142 # readline/history support for wpa_cli
143 echo "CONFIG_READLINE=y" >> .config
144 fi
145
146 # SSL authentication methods
147 if use ssl ; then
148 echo "CONFIG_TLS=openssl" >> .config
149 echo "CONFIG_SMARTCARD=y" >> .config
150 elif use gnutls ; then
151 echo "CONFIG_TLS=gnutls" >> .config
152 echo "CONFIG_GNUTLS_EXTRA=y" >> .config
153 else
154 echo "CONFIG_TLS=internal" >> .config
155 fi
156
157 if use kernel_linux ; then
158 # Linux specific drivers
159 echo "CONFIG_DRIVER_ATMEL=y" >> .config
160 #echo "CONFIG_DRIVER_BROADCOM=y" >> .config
161 #echo "CONFIG_DRIVER_HERMES=y" >> .config
162 echo "CONFIG_DRIVER_HOSTAP=y" >> .config
163 echo "CONFIG_DRIVER_IPW=y" >> .config
164 echo "CONFIG_DRIVER_NDISWRAPPER=y" >> .config
165 echo "CONFIG_DRIVER_NL80211=y" >> .config
166 #echo "CONFIG_DRIVER_PRISM54=y" >> .config
167 echo "CONFIG_DRIVER_RALINK=y" >> .config
168 echo "CONFIG_DRIVER_WEXT=y" >> .config
169 echo "CONFIG_DRIVER_WIRED=y" >> .config
170
171 if use madwifi ; then
172 # Add include path for madwifi-driver headers
173 echo "CFLAGS += -I/usr/include/madwifi" >> .config
174 echo "CONFIG_DRIVER_MADWIFI=y" >> .config
175 fi
176
177 if use ps3 ; then
178 echo "CONFIG_DRIVER_PS3=y" >> .config
179 fi
180
181 elif use kernel_FreeBSD ; then
182 # FreeBSD specific driver
183 echo "CONFIG_DRIVER_BSD=y" >> .config
184 fi
185
186 # Wi-Fi Protected Setup (WPS)
187 if use wps ; then
188 echo "CONFIG_WPS=y" >> .config
189 fi
190
191 # Enable mitigation against certain attacks against TKIP
192 echo "CONFIG_DELAYED_MIC_ERROR_REPORT=y" >> .config
193
194 # If we are using libnl 2.0 and above, enable support for it
195 # Bug 382159
196 # Removed for now, since the 3.2 version is broken, and we don't
197 # support it.
198 #if has_version ">=dev-libs/libnl-2.0"; then
199 # echo "CONFIG_LIBNL20=y" >> .config
200 #fi
201
202 if use qt4 ; then
203 pushd "${S}"/wpa_gui-qt4 > /dev/null
204 eqmake4 wpa_gui.pro
205 popd > /dev/null
206 fi
207 }
208
209 src_compile() {
210 einfo "Building wpa_supplicant"
211 emake
212
213 if use wimax; then
214 emake -C ../src/eap_peer clean
215 emake -C ../src/eap_peer
216 fi
217
218 if use qt4 ; then
219 pushd "${S}"/wpa_gui-qt4 > /dev/null
220 einfo "Building wpa_gui"
221 emake
222 popd > /dev/null
223 fi
224 }
225
226 src_install() {
227 dosbin wpa_supplicant
228 dobin wpa_cli wpa_passphrase
229
230 # baselayout-1 compat
231 if has_version "<sys-apps/baselayout-2.0.0"; then
232 dodir /sbin
233 dosym /usr/sbin/wpa_supplicant /sbin/wpa_supplicant
234 dodir /bin
235 dosym /usr/bin/wpa_cli /bin/wpa_cli
236 fi
237
238 if has_version ">=sys-apps/openrc-0.5.0"; then
239 newinitd "${FILESDIR}/${PN}-init.d" wpa_supplicant
240 newconfd "${FILESDIR}/${PN}-conf.d" wpa_supplicant
241 fi
242
243 exeinto /etc/wpa_supplicant/
244 newexe "${FILESDIR}/wpa_cli.sh" wpa_cli.sh
245
246 dodoc ChangeLog {eap_testing,todo}.txt README{,-WPS} \
247 wpa_supplicant.conf
248
249 doman doc/docbook/*.{5,8}
250
251 if use qt4 ; then
252 into /usr
253 dobin wpa_gui-qt4/wpa_gui
254 doicon wpa_gui-qt4/icons/wpa_gui.svg
255 make_desktop_entry wpa_gui "WPA Supplicant Administration GUI" "wpa_gui" "Qt;Network;"
256 fi
257
258 use wimax && emake DESTDIR="${D}" -C ../src/eap_peer install
259
260 if use dbus ; then
261 pushd "${S}"/dbus > /dev/null
262 insinto /etc/dbus-1/system.d
263 newins dbus-wpa_supplicant.conf wpa_supplicant.conf
264 insinto /usr/share/dbus-1/system-services
265 doins fi.epitest.hostap.WPASupplicant.service fi.w1.wpa_supplicant1.service
266 keepdir /var/run/wpa_supplicant
267 popd > /dev/null
268 fi
269
270 # systemd stuff
271 systemd_dounit "${FILESDIR}"/wpa_supplicant.service
272 systemd_newunit "${FILESDIR}"/wpa_supplicant_at.service 'wpa_supplicant@.service'
273 }
274
275 pkg_postinst() {
276 einfo "If this is a clean installation of wpa_supplicant, you"
277 einfo "have to create a configuration file named"
278 einfo "/etc/wpa_supplicant/wpa_supplicant.conf"
279 einfo
280 einfo "An example configuration file is available for reference in"
281 einfo "/usr/share/doc/${PF}/"
282
283 if [[ -e ${ROOT}etc/wpa_supplicant.conf ]] ; then
284 echo
285 ewarn "WARNING: your old configuration file ${ROOT}etc/wpa_supplicant.conf"
286 ewarn "needs to be moved to ${ROOT}etc/wpa_supplicant/wpa_supplicant.conf"
287 fi
288
289 if use madwifi ; then
290 echo
291 einfo "This package compiles against the headers installed by"
292 einfo "madwifi-old, madwifi-ng or madwifi-ng-tools."
293 einfo "You should re-emerge ${PN} after upgrading these packages."
294 fi
295
296 # Mea culpa, feel free to remove that after some time --mgorny.
297 local fn
298 for fn in wpa_supplicant{,@wlan0}.service; do
299 if [[ -e "${ROOT}"/etc/systemd/system/network.target.wants/${fn} ]]
300 then
301 ebegin "Moving ${fn} to multi-user.target"
302 mv "${ROOT}"/etc/systemd/system/network.target.wants/${fn} \
303 "${ROOT}"/etc/systemd/system/multi-user.target.wants/
304 eend ${?} \
305 "Please try to re-enable ${fn}"
306 fi
307 done
308 }

  ViewVC Help
Powered by ViewVC 1.1.20